//Emote_Alarm.cs

datablock ParticleData(NotifyParticle)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = -3;
   inheritedVelFactor   = 0.0;
   windCoefficient      = 0;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 0;
   useInvAlpha          = false;
   textureName          = "base/data/particles/star1";
   colors[0]     = "3 0 1 2";
   colors[1]     = "1 2 1 3";
   colors[2]     = "3 1 2 0";
   sizes[0]      = 0.9;
   sizes[1]      = 0.9;
   sizes[2]      = 0.9;
   times[0]      = 0.0;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(NotifyEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   ejectionOffset   = 0;
   velocityVariance = 0;
   thetaMin         = 0.0;
   thetaMax         = 0.0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   lifeTimeMS = 100;
   particles = "NotifyParticle";

   doFalloff = false; //if we do fall off with this emitter it ends up flickering, for most emitters you want this TRUE

   emitterNode = GenericEmitterNode;        //used when placed on a brick
   pointEmitterNode = TenthEmitterNode; //used when placed on a 1x1 brick

   uiName = "Emote - Notify";
};


//we cant spawn explosions, so this is a workaround for now
datablock ShapeBaseImageData(NotifyImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 0.350;
	stateEmitter[1]					= NotifyEmitter;
	stateEmitterTime[1]				= 0.350;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};

function notifyImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}


if(isfile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

	if(!$Pref::Server::LCchatDistance)
		$Pref::Server::LCchatDistance = 15;

	Rtb_registerPref("Chat Distance","Local Chat","$pref::server::lcChatDistance","int 0 100","Server_localChat","15","0","1","localChat_distance");
	Rtb_registerPref("Allow dead talking?","Local Chat","$pref::server::lcADT","bool","Server_localChat","0","0","1","localChat_adt");
	Rtb_registerPref("Out of range message","Local Chat","$pref::server::lcOOrM","string 30","Server_localChat","\c3There is nobody is around but you!","0","1","localChat_OORM");

}
else
{
	$pref::Server::lcChatDistance = 15;
	$pref::Server::LcAdt = 0;
	$pref::Server::LCOORM = "\c3There is nobody is around but you!";
}

function localChat_OORM()
{
	if($pref::Server::lcOORM $= "")
		$pref::server::lcOORM = "There is nobody is around but you!";
}

function localChat_distance()
{
	if($pref::Server::lcChatDistance <= 4 || $pref::server::lcchatDistance $= "")
		$pref::server::lcChatDistance = 5;
}

function localChat_Adt(%bool)
{
echo(%bool);
}

function serverCmdL(%client)
{
	if(%client.IsSuperAdmin)
	{
		$localchat_toggle++;
	
		if($localchat_toggle ==1)
		{
			$local_chat=1;
			messageAll('',"\c6Local chat turned on!");
		}
		
		else
		
		if($localchat_toggle >=2)
		{
			$local_chat=0;
			$localchat_toggle=0;
			messageAll('',"\c6Local chat turned off!");
		}
	}
}

function ServerCmdLcHelp(%client)
{
	commandToClient(%client,'messageBoxOk',"Local Chat Information [Mod by Curse]","How this works:\n\nYou say something, but only the people in the radius, set by the host (which is currently a radius of "@$pref::Server::lcChatDistance@") can hear you.");
}

package local_chat
{
	function GameConnection::SpawnPlayer(%client)
	{
		parent::SpawnPlayer(%client);
		if(%client.lcNotified $= "")
		{
			if($local_Chat == false)
				return;

			messageClient(%client,'',"\c6The addon made by Curse, Local Chat is enabled. Type /lcHelp to see how it works.");
			%client.lcNotified = 1;
		}
	}
	function ServerCmdTeamMessageSent(%client,%text)
	{
		if($local_chat==false)
			parent::ServerCmdTeamMessageSent(%client,%text);

		else
		{
			if(!isObject(%client.player))
			{
				if($pref::Server::lcADT == 0)
				{
					messageClient(%client,'',"\c6You cannot talk without a body!");
					return;
				}
				else
				{
					ServerCmdDeadTalk(%client,%text);			
					return;
				}	
			}

			if($Pref::Server::ETardFilter == 1)
				for(%i=0; %i<getWordCount(%text); %i++)
				{
					%word=getWord(%text,%i);
					for(%j=0; %j<getwordCount($Pref::Server::ETardList); %j++)
						if(%word $= getWord($Pref::Server::ETardList,%j))
						{
							messageClient(%client,'',"\c5This is a civilized game. Please use full words.");
							return;
						}
				}
			serverCmdLocalMessageSent(%client,%text);
		}
	}

	function serverCmdMessageSent(%client,%text)
	{
		if($local_Chat == true && !isObject(%client.player))
		{
			if(getSubstr(%text,0,1) $= "#" && isFile("Add-ons/server_radopm.zip"))
			{
				parent::serverCmdMessageSent(%client,%text);
				return;
			}
			if($pref::Server::lcADT == 0)
			{
				messageClient(%client,'',"\c6You cannot talk without a body!");
				return;
			}
			else
			{
				ServerCmdDeadTalk(%client,%text);			
				return;
			}
		}

		if($local_chat==true && isObject(%client.player))
		{
            		if(getSubstr(%text,0,1) $= "#" && isFile("add-ons/server_radio.zip"))
            		{
               			parent::serverCmdMessageSent(%client,%text);
                		return;
            		}
			if($Pref::Server::ETardFilter == 1)
				for(%i=0; %i<getWordCount(%text); %i++)
				{
					%word=getWord(%text,%i);
					for(%j=0; %j<getwordCount($Pref::Server::ETardList); %j++)
						if(%word $= getWord($Pref::Server::ETardList,%j))
						{
							messageClient(%client,'',"\c5This is a civilized game. Please use full words.");
							return;
						}
				}

			serverCmdLocalMessageSent(%client,%text);
		}

		
		if($local_chat == false || !isObject(%client.player))
			parent::serverCmdMessageSent(%client,%text);

	}
};
activatePackage(local_chat);

function serverCmdlocalMessageSent(%client,%text)
{
	if($local_chat == false || %text $= "")
		return;
		
	%text=stripMlControlChars(%text);

	if(%client.LastLocalMessage $= %text)
	{
		messageClient(%client,'',"\No spamming.");
		return;
	}

	else
		%client.lastLocalMessage=%text;

	for(%i=0; %i<clientGroup.getCount(); %i++)
	{
		%player=clientGroup.getObject(%i);
		
		if(%client.player !$= "" && %client.player !$= "0")
			if(vectorDist(%client.player.getTransform(),%player.player.getTransform())<$pref::Server::lcChatDistance)
			{
				messageClient(%player,'',"\c7"@%client.clanprefix@"\c3"@%client.name@"\c7"@%client.clansuffix @" \c3says, \c6\""@%text@"\"");
				%client.player.emote(notifyImage);
				if(%player == %client)
					continue;

				if(%playersWhoHeard $= "")
					%playersWhoHeard=%player.name;
				else
					%playersWhoHeard=%playersWhoHeard @", "@ %player.name;
			}
	}

	if(%playersWhoHeard !$= "")
		bottomPrint(%client,"\c3Players who heard you : \c6"@%playersWhoHeard@".",3);
	else
		bottomPrint(%client,"                             "@$pref::Server::LCOORM,3);

}

function ServerCmdDeadTalk(%client,%text)
{
	if($local_chat == False)
		return;
	for(%i=0; %i<clientGroup.getcount(); %i++)
	{
		%cl = clientGroup.getObject(%i);

		if(isObject(%cl.player))continue;
		
		messageClient(%cl,'',"\c0[DEAD]\c7"@%client.clanPrefix@"\c3"@%client.name@"\c7"@%client.clanSuffix@"\c0[DEAD]\c6: "@%text@"");
	}
}